other distros move to nodemanager that has a single specfile for all packages
[build.git] / lbuild-nightly.sh
index 39afca2..d605573 100755 (executable)
@@ -12,10 +12,11 @@ export PATH=$PATH:/bin:/sbin
 
 # default values, tunable with command-line options
 DEFAULT_FCDISTRO=f20
-DEFAULT_PLDISTRO=planetlab
+DEFAULT_PLDISTRO=lxc
 DEFAULT_PERSONALITY=linux64
-DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
+DEFAULT_MAILDEST="build at onelab.eu"
 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
+DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
 
 # default gpg path used in signing yum repo
 DEFAULT_GPGPATH="/etc/planetlab"
@@ -146,8 +147,8 @@ function pretty_duration () {
 function failure() {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
+    if  [ -z "$WEBLOG" ] ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
        WEBBASE=/tmp/lbuild-early-$(date +%Y-%m-%d)
        WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
@@ -158,16 +159,16 @@ function failure() {
     (echo -n "============================== $COMMAND: failure at " ; date ; \
        webpublish tail --lines=1000 $WEBLOG) | \
        webpublish_cp_stdin_to_file $WEBBASE.ko ||:
-    if [ -n "$MAILTO" ] ; then
+    if [ -n "$MAILDEST" ] ; then
        ( \
            echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
+           echo "To: $MAILDEST" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
            echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
            echo "........................................" ; \
            webpublish tail --lines=1000 $WEBLOG ) | \
-           sendmail $MAILTO
+           sendmail $MAILDEST
     fi
     exit 1
 }
@@ -175,8 +176,8 @@ function failure() {
 function success () {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
+    if [ -z "$WEBLOG" ] ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
        WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
     fi
@@ -206,17 +207,17 @@ function success () {
     fi
     BUILD_END=$(date +'%H:%M')
     BUILD_END_S=$(date +'%s')
-    if [ -n "$MAILTO" ] ; then
+    if [ -n "$MAILDEST" ] ; then
        ( \
            echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
+           echo "To: $MAILDEST" ; \
            echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
             [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
            [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
            echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(pretty_duration $(($BUILD_END_S-$BUILD_BEG_S)))" ; \
-           ) | sendmail $MAILTO
+           ) | sendmail $MAILDEST
     fi
     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
     # doesn't fix the problem, I'll remove it -- Sapan.
@@ -248,7 +249,7 @@ function build () {
     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
-    MAKEVARS=("MAILTO=${MAILTO}" "${MAKEVARS[@]}")
+    MAKEVARS=("MAILDEST=${MAILDEST}" "${MAKEVARS[@]}")
     MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
     MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
     MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
@@ -311,13 +312,16 @@ function run_log () {
     # toss the build in the bargain, so the tests don't need to mess with extracting it
     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/build ${testmaster_ssh}:${BASE}/
 
-    # invoke test on testbox - pass url and build url - so the tests can use vtest-init-lxc.sh
+    # invoke test on testbox - pass url and build url - so the tests can use lbuild-initvm.sh
     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
 
     # temporarily turn off set -e
     set +e
+    trap - ERR INT
     ssh 2>&1 ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
 
+    set -e
+    trap failure ERR INT
     # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
     echo "retcod from run_log" $retcod
     case $retcod in
@@ -326,7 +330,6 @@ function run_log () {
        *) success="";   IGNORED="" ;; 
     esac
 
-    set -e
     # gather logs in the build vm
     mkdir -p $(rootdir $BASE)/build/testlogs
     rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ $(rootdir $BASE)/build/testlogs
@@ -446,7 +449,7 @@ function usage () {
     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
-    echo " -m mailto - no default"
+    echo " -m mailto - defaults to $DEFAULT_MAILDEST"
     echo " -s build_scm_url - git URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
     echo "    define GIT tag or branch name appending @tagname to url"
     echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
@@ -482,6 +485,7 @@ function usage () {
 function main () {
 
     set -e
+    trap failure ERR INT
 
     # parse arguments
     MAKEVARS=()
@@ -505,7 +509,7 @@ function main () {
            -f) FCDISTRO=$2; shift 2 ;;
            -d) PLDISTRO=$2; shift 2 ;;
            -p) PERSONALITY=$2; shift 2 ;;
-           -m) MAILTO=$2; shift 2 ;;
+           -m) MAILDEST=$2; shift 2 ;;
            -s) BUILD_SCM_URL=$2; shift 2 ;;
            -t) PLDISTROTAGS=$2; shift 2 ;;
            -b) BASE=$2; shift 2 ;;
@@ -563,6 +567,7 @@ function main () {
     [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
     [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
     [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
+    [ -z "$MAILDEST" ] && MAILDEST=$(echo $DEFAULT_MAILDEST | sed -e 's, at ,@,')
     [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
@@ -574,7 +579,7 @@ function main () {
     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
 
-    [ -n "$DRY_RUN" ] && MAILTO=""
+    [ -n "$DRY_RUN" ] && MAILDEST=""
 
     # elaborate the extra args to be passed to run_log
     for config in ${TESTCONFIG} ; do
@@ -644,7 +649,7 @@ function main () {
            # for efficiency, crop everything in one make run
            tmp=/tmp/${BASE}-env.sh
            virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip \
-               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
+               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILDEST ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
            . $tmp
            rm -f $tmp
            # update build
@@ -654,7 +659,7 @@ function main () {
            rm -f /build/MODULES/tests
            options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
            [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
-           [ -n "$MAILTO" ] && options=(${options[@]} -m $MAILTO)
+           [ -n "$MAILDEST" ] && options=(${options[@]} -m $MAILDEST)
            [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
            [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
            [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
@@ -686,7 +691,10 @@ function main () {
            GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
            GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
            GIT_TAG=${GIT_TAG:-master}
-           mkdir -p $tmpdir; git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -
+           mkdir -p $tmpdir 
+            ( git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -) || \
+               ( echo "==================== git archive FAILED, trying git clone instead" ; \
+                 git clone $GIT_REPO $tmpdir && cd $tmpdir && git checkout $GIT_TAG && rm -rf .git)
 
             # Create lxc vm
            cd $tmpdir
@@ -696,7 +704,6 @@ function main () {
            rm -rf $tmpdir
            # Extract build again - in the vm
            [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           # xxx not working as of now - waiting for Sapan to look into this
            virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
        fi
        echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
@@ -735,6 +742,7 @@ function main () {
 
        # publish to the web so run_log can find them
        set +e
+       trap - ERR INT
        webpublish rm -rf $WEBPATH/$BASE 
        # guess if we've been doing any debian-related build
        if [ ! -f $(rootdir $BASE)/etc/debian_version  ] ; then
@@ -753,6 +761,7 @@ function main () {
        release=$(rootdir $BASE)/build/myplc-release
        [ -f $release ] && webpublish_rsync_files $WEBPATH/$BASE $release
        set -e
+       trap failure ERR INT
 
         # create yum repo and sign packages.
        if [ -n "$SIGNYUMREPO" ] ; then